Index: greenstone3/trunk/web/WEB-INF/classes/interface_default_el.properties
===================================================================
--- greenstone3/trunk/web/WEB-INF/classes/interface_default_el.properties	(revision 14429)
+++ greenstone3/trunk/web/WEB-INF/classes/interface_default_el.properties	(revision 14429)
@@ -0,0 +1,69 @@
+home_b=ÎÎ¡Î§ÎÎÎ Î£ÎÎÎÎÎ
+pref_b=ÎÎ ÎÎÎÎÎÎ£
+help_b=ÎÎÎÎÎÎÎ
+about_t=Î Î»Î·ÏÎ¿ÏÎ¿ÏÎ¯ÎµÏ (Î³Î¹Î±)
+texticonpdf=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® PDF
+texticonps=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® PostScript 
+texticonrtf=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® RTF 
+texticonmsword=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® Microsoft Word 
+texticonppt=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® PowerPoint 
+texticonxls=ÎÎœÎ¿Î¹Î³ÎŒÎ± ÏÎ¿Ï
+ ÎµÎ³Î³ÏÎ¬ÏÎ¿Ï
+ ÏÎµ ÎŒÎ¿ÏÏÎ® Microsoft Excel 
+gsdl=Î»Î¿Î³Î¹ÏÎŒÎ¹ÎºÏ ÏÎ·Ï ÎšÎ·ÏÎ¹Î±ÎºÎ®Ï ÎÎ¹Î²Î»Î¹Î¿ÎžÎ®ÎºÎ·Ï ÏÎ¿Ï
+ Greenstone
+home_tip=ÎÏÏÎ¹ÎºÎ® ÏÎµÎ»Î¯ÎŽÎ±
+help_tip=ÎÎ¿Î®ÎžÎµÎ¹Î±
+pref_tip=ÎÎ»Î»Î¬Î¶Î¿ÎœÏÎ±Ï ÏÎ¹Ï ÎÏÎ¹Î»Î¿Î³Î­Ï ÏÎ±Ï/ preferences
+home_t=ÎÏÏÎ¹ÎºÎ® ÏÎµÎ»Î¯ÎŽÎ±
+home.aboutgs=Î£ÏÎµÏÎ¹ÎºÎ¬ ÎŒÎµ ÏÎ¿ Greenstone
+aboutpage=ÏÏÎµÏÎ¹ÎºÎ¬ ÎŒÎµ Î±Ï
+ÏÎ®Îœ ÏÎ· ÏÏ
+Î»Î»Î¿Î³Î®
+about.howtofind=Î ÏÏ ÎœÎ± Î²ÏÎµÎ¯ÏÎµ ÏÎ»Î·ÏÎ¿ÏÎ¿ÏÎ¯ÎµÏ Î³Î¹Î± ÏÎ· ÏÏ
+Î»Î»Î¿Î³Î® {0} 
+pref.searchpref=ÂšÎÏÎ¹Î»Î¿Î³Î­Ï Î±ÎœÎ±Î¶Î®ÏÎ·ÏÎ·Ï
+pref.prespref=ÎÏÎ¹Î»Î¿Î³Î­Ï ÏÎ±ÏÎ¿Ï
+ÏÎ¯Î±ÏÎ·Ï
+pref.interfacelang=Î³Î»ÏÏÏÎ± ÎµÏÎ¹ÏÎ¬ÎœÎµÎ¹Î±Ï ÎµÏÎ³Î±ÏÎ¯Î±Ï:
+pref.encoding=ÎÏÎŽÎ¹ÎºÎ¿ÏÎ¿Î¯Î·ÏÎ·:
+pref.all=ÏÎ»Î±
+pref.set_prefs=Î¡ÏÎžÎŒÎ¹ÏÎ· ÎµÏÎ¹Î»Î¿Î³ÏÎœ
+query.wordcount=ÎÎ­ÏÏÎ·ÏÎ· ÎÎ­ÎŸÎµÏÎœ: 
+query.nodocsmatch=ÎÎµÎœ Î²ÏÎ­ÎžÎ·ÎºÎµ ÎºÎ±ÎœÎ­ÎœÎ± Î­Î³Î³ÏÎ±ÏÎ¿ ÏÎ¿Ï
+ ÎœÎ± ÏÎ±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ ÏÏÎ·Îœ Î±ÎœÎ±Î¶Î®ÏÎ·ÏÎ® ÏÎ±Ï.
+query.onedocsmatch=1 Î­Î³Î³ÏÎ±ÏÎ¿ ÏÎ±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ ÏÏÎ·Îœ Î±ÎœÎ±Î¶Î®ÏÎ·ÏÎ·.
+query.matches=ÎÏÎ¿ÏÎµÎ»Î­ÏÎŒÎ±ÏÎ±
+query.results=Î±ÏÎ¿ÏÎµÎ»Î­ÏÎŒÎ±ÏÎ±
+document.gotopage=ÏÎ®Î³Î±Î¹ÎœÎµÏÎµ ÏÏÎ· ÏÎµÎ»Î¯ÎŽÎ±
+doc.expand_doc_b=ÎÎÎÎÎÎÎ¥Î£Î\nÎÎÎÎÎÎÎÎ¥
+doc.expand_doc_tip=ÎÎŒÏÎ¬ÎœÎ¹ÏÎµ Î¿Î»ÏÎºÎ»Î·ÏÎ¿ ÏÎ¿ ÎºÎµÎ¯ÎŒÎµÎœÎ¿
+doc.contract_doc_b=ÎÎÎÎÎÎÎ\nÎ£Î¥ÎÎÎÎÎÎÎÎ¥
+doc.contract_doc_tip=ÎÎŒÏÎ¬ÎœÎ¹ÏÎ· ÎºÎµÎ¹ÎŒÎ­ÎœÎ¿Ï
+ ÎŒÏÎœÎ¿ Î³Î¹Î± ÏÎ·Îœ ÏÏÎ¿ÎµÏÎ¹Î»ÎµÎ³ÎŒÎ­ÎœÎ· ÎµÎœÏÏÎ·ÏÎ±
+doc.expand_contents_b=ÎÎÎÎÎÎÎ¥Î£Î Î€Î©Î\nÎ ÎÎ¡ÎÎÎ§ÎÎÎÎÎ©Î
+doc.expand_contents_tip=ÎÎœÎ¬ÏÏÏ
+ÎŸÎ· ÏÎ¿Ï
+ ÏÎ¯ÎœÎ±ÎºÎ± ÏÎµÏÎ¹ÎµÏÎ¿ÎŒÎ­ÎœÏÎœ
+doc.contract_contents_b=Î ÎÎ¡ÎÎÎ§ÎÎÎÎÎ\nÎ£Î¥ÎÎÎÎÎÎÎÎ¥
+doc.contract_contents_tip=Î£ÏÎŒÏÏÎ·ÎŸÎ· ÏÎ¿Ï
+ ÏÎ¯ÎœÎ±ÎºÎ± ÏÎµÏÎ¹ÎµÏÎ¿ÎŒÎ­ÎœÏÎœ
+doc.detach_page_b=ÎÎ ÎÎ£Î ÎÎ£Î
+doc.detach_page_tip=ÎÎœÎ¿Î¹ÎŸÎµ Î±Ï
+ÏÎ® ÏÎ· ÏÎµÎ»Î¯ÎŽÎ± ÏÎµ ÎœÎ­Î¿ ÏÎ±ÏÎ¬ÎžÏ
+ÏÎ¿
+param.sortBy.1=ÏÎ±ÎŸÎ¹ÎœÏÎŒÎ·ÏÎ·
+param.sortBy.0=ÏÏ
+ÏÎ¹ÎºÏ
+param.fqf=... ÏÎµ ÏÎµÎŽÎ¯Î¿ 
+param.fqf.all=ÏÎ»Î± ÏÎ± ÏÎµÎŽÎ¯Î± 