Index: /greenstone3/trunk/web/WEB-INF/classes/interface_default_bn.properties
===================================================================
--- /greenstone3/trunk/web/WEB-INF/classes/interface_default_bn.properties	(revision 14449)
+++ /greenstone3/trunk/web/WEB-INF/classes/interface_default_bn.properties	(revision 14449)
@@ -0,0 +1,45 @@
+home_b=àŠ¹à§àŠ® / àŠà§àŠ¹
+pref_b=àŠªàŠàŠšà§àŠŠ
+help_b=àŠžàŠŸàŠ¹àŠŸàŠ¯à§àŠ¯
+about_t=àŠªàŠŸàŠ€àŠŸàŠàŠ¿àŠ° àŠžàŠ®à§àŠªàŠ°à§àŠà§ àŠàŠŸàŠšà§àŠš
+texticonpdf=àŠªàŠ¿àŠ¡àŠ¿àŠàŠ« àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+texticonps=àŠªà§àŠžà§àŠàŠà§àŠ°àŠ¿àŠªà§àŠ àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+texticonrtf=àŠàŠ°àŠàŠ¿àŠàŠ« àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+texticonmsword=àŠ®àŠŸàŠàŠà§àŠ°à§àŠžàŠ«àŠ àŠà§àŠŸàŠ°à§àŠ¡ àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+texticonppt=àŠªàŠŸàŠà§àŠŸàŠ° àŠªà§à§àŠšà§àŠ àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+texticonxls=àŠ®àŠŸàŠàŠà§àŠ°à§àŠžàŠ«àŠ àŠàŠàŠžà§àŠ² àŠ«àŠŸàŠàŠ²àŠàŠ¿ àŠŠà§àŠà§àŠš
+gsdl=àŠšàŠ¿àŠàŠàŠ¿àŠ²à§àŠ¯àŠŸàŠšà§àŠ¡ àŠ¡àŠ¿àŠàŠ¿àŠàŠŸàŠ² àŠ²àŠŸàŠàŠ¬à§àŠ°à§àŠ°à§ àŠžàŠ«àŠàŠà§àŠŸàŠ°
+home_tip=àŠ¶à§àŠ°à§àŠ° àŠªàŠŸàŠ€àŠŸ
+help_tip=àŠžàŠŸàŠ¹àŠŸàŠ¯à§àŠ¯àŠ°  àŠàŠšà§àŠ¯ àŠàŠ àŠªàŠŸàŠ€àŠŸàŠàŠ¿ àŠŠà§àŠà§àŠš 
+pref_tip=àŠàŠªàŠšàŠŸàŠ° àŠªàŠàŠšà§àŠŠ àŠªàŠ°àŠ¿àŠ¬àŠ°à§àŠ€àŠš àŠ¹àŠà§àŠà§
+home_t=àŠ¶à§àŠ°à§àŠ° àŠªàŠŸàŠ€àŠŸ
+aboutpage=àŠàŠ àŠžàŠàŠà§àŠ°àŠ¹ àŠžàŠ®à§àŠ¬àŠšà§àŠ§à§
+about.howtofind=àŠàŠ¿ àŠàŠ°à§ àŠžwàŠà§àŠ°àŠ¹ àŠ¥à§àŠà§ àŠ€àŠ¥àŠ¯ àŠàŠà§àŠàŠ€à§ àŠ¹à§ {0} àŠžwàŠà§àŠ°àŠ¹ 
+pref.searchpref=àŠªàŠàŠšà§àŠŠ àŠàŠà§àŠàŠŸ
+pref.prespref=àŠàŠªàŠžà§àŠ¥àŠŸàŠªàŠšà§àŠ° àŠªàŠàŠšà§àŠŠ
+pref.interfacelang=àŠ¬à§àŠ¯àŠ¬àŠ¹àŠŸàŠ°àŠ¿àŠ àŠ­àŠŸàŠ·àŠŸ
+pref.encoding=àŠàŠšàŠà§àŠ¡àŠ¿w àŠ
+pref.all=àŠžàŠ¬àŠàŠ¿àŠà§
+pref.set_prefs=àŠªàŠàŠšà§àŠŠ àŠ àŠ¿àŠ àŠàŠ°àŠŸ
+query.wordcount=àŠ¶àŠ¬à§àŠŠ àŠàŠ£àŠšàŠŸ àŠ
+query.nodocsmatch=àŠà§àŠš àŠšàŠ¥àŠ¿ àŠªà§àŠ°àŠ¶à§àŠšà§àŠ° àŠžàŠŸàŠ¥à§ àŠ®àŠ¿àŠ²à§àŠà§ àŠšàŠŸà¥€
+query.onedocsmatch=àŠàŠàŠàŠ¿ àŠšàŠ¥àŠ¿ àŠªà§àŠ°àŠ¶à§àŠšà§àŠ° àŠžàŠŸàŠ¥à§ àŠ®àŠ¿àŠ²à§àŠà§à¥€
+query.matches=àŠ®à§àŠ²à§
+query.results=àŠ«àŠ²àŠŸàŠ«àŠ²àŠà§àŠ²àŠ¿
+document.gotopage=àŠªàŠŸàŠ€àŠŸà§ àŠ¯à§àŠ€à§
+doc.expand_doc_b=àŠžàŠ®à§àŠªà§àŠ°àŠžàŠŸàŠ°àŠ£\nàŠ®à§àŠ²àŠªàŠŸàŠ 
+doc.expand_doc_tip=àŠžàŠ¬ àŠ²à§àŠàŠŸ àŠŠà§àŠàŠŸàŠš
+doc.contract_doc_b=àŠà§àŠà§àŠ€àŠ¿\nàŠ®à§àŠ²àŠªàŠŸàŠ 
+doc.contract_doc_tip=àŠ¶à§àŠ§à§àŠ®àŠŸàŠ€à§àŠ° àŠ¬àŠ°à§àŠ€àŠ®àŠŸàŠšà§ àŠàŠ¿àŠ¹à§àŠšàŠ¿àŠ€  àŠ
+àŠàŠ¶ àŠŠà§àŠàŠŸàŠš
+doc.expand_contents_b=àŠžàŠ®à§àŠªà§àŠ°àŠžàŠŸàŠ°àŠ£\nàŠžà§àŠàŠ¿àŠªàŠ€à§àŠ°
+doc.expand_contents_tip=àŠ¬àŠ¿àŠ¬àŠ°àŠšà§ àŠ€àŠŸàŠ²àŠ¿àŠàŠŸàŠàŠ¿  àŠžàŠ®à§àŠªà§àŠ°àŠžàŠŸàŠ°àŠ¿àŠ€  àŠàŠ°à§àŠ£
+doc.contract_contents_b=àŠà§àŠà§àŠ€àŠ¿\nàŠžà§àŠàŠ¿àŠªàŠ€à§àŠ°
+doc.contract_contents_tip=àŠà§àŠ¬àŠ¿àŠ²à§àŠ° àŠ¬àŠ¿àŠ¬àŠ°àŠ£àŠà§àŠ²àŠ¿ àŠ®à§àŠà§ àŠ«à§àŠ²à§àŠš
+doc.detach_page_b=àŠàŠ²àŠŸàŠŠàŠŸ
+doc.detach_page_tip=àŠšàŠ€à§àŠš àŠàŠŸàŠšàŠŸàŠ²àŠŸà§ àŠàŠ àŠªàŠŸàŠ€àŠŸàŠàŠ¿ àŠà§àŠ²à§àŠš
+param.sortBy.1=àŠ
+àŠ¬àŠžà§àŠ¥àŠŸàŠš
+param.sortBy.0=àŠžàŠŸàŠ§àŠŸàŠ°àŠ£
+param.fqf=àŠà§àŠ·à§àŠ€à§àŠ°à§
+param.fqf.all=àŠžàŠ¬ àŠà§àŠ·à§àŠ€à§àŠ°  