Index: /greenstone3/trunk/web/WEB-INF/classes/interface_default_mr.properties
===================================================================
--- /greenstone3/trunk/web/WEB-INF/classes/interface_default_mr.properties	(revision 14457)
+++ /greenstone3/trunk/web/WEB-INF/classes/interface_default_mr.properties	(revision 14457)
@@ -0,0 +1,50 @@
+home_b=à€®à¥à€à¥à€¯ à€ªà€Ÿà€š
+pref_b=à€ªà¥à€°à€Ÿà€§à€Ÿà€šà¥à€¯
+help_b=à€®à€Šà€€
+about_t=à€ªà€Ÿà€šà€Ÿà€à€µà€¿à€·à€¯à¥ 
+texticonpdf=à€ªà¥à€¡à¥à€« à€Šà€žà¥à€€à€à€µà€ à€ªà€¹à€Ÿ.
+texticonps=à€ªà¥à€žà¥à€à€žà¥à€°à€¿à€ªà€ à€Šà€žà¥à€€à€à€µà€ à€Šà€Ÿà€à€µà€Ÿ
+texticonrtf=à€à€°.à€à¥.à€« à€Šà€žà¥à€€à€à€µà€ à€ªà€¹à€Ÿ.
+texticonmsword=à€¹à€Ÿ à€Šà€žà¥à€€à€à€µà€ à€®à€Ÿà€¯à€à¥à€à¥à€žà¥à€«à¥à€ à€µà€¡à¥à€° à€®à€§à¥à€¯à¥ à€Šà€Ÿà€à€µà€Ÿ
+texticonppt=à€ªà¥à€µà€° à€ªà¥à€à€à€ à€Šà€žà¥à€€à€à€µà€ à€ªà€¹à€Ÿ.
+texticonxls=à€®à€Ÿà€¯à€à¥à€°à¥à€žà¥à€«à¥à€ à€à€à¥à€žà¥à€² à€Šà€žà¥à€€à€à€µà€ à€¬à€à€Ÿ
+gsdl=à€à¥à€°à¥à€šà€žà¥à€à¥à€š à€¡à€¿à€à¥à€à€² à€²à€Ÿà€¯à€¬à¥à€°à€°à¥  à€žà¥
+à€Ÿà€«à¥à€à€µà¥à€
+à€°
+home_tip=à€®à¥à€à¥à€¯ à€ªà€Ÿà€š
+help_tip=à€®à€Šà€€à¥à€à¥ à€ªà€Ÿà€š
+pref_tip=à€ªà¥à€°à€Ÿà€§à€Ÿà€šà¥à€¯ à€¬à€Šà€²à€Ÿ
+home_t=à€®à¥à€à¥à€¯ à€ªà€Ÿà€š
+home.aboutgs=à€à¥à€°à¥à€šà€žà¥à€à¥à€š à€µà€¿à€·à€¯à¥
+aboutpage=à€žà€à€à€²à€šà€Ÿ à€žà€à€°à¥à€Šà€­à€Ÿà€€
+about.howtofind=à€žà€à€à¥à€°à€¹à€šà€Ÿà€µ à€žà€à€à¥à€°à€¹ à€à€žà€Ÿ à€¶à¥à€§à€Ÿà€µà€Ÿ
+pref.searchpref=à€ªà¥à€°à€Ÿà€§à€Ÿà€šà¥à€¯ à€šà€¿à€¶à¥à€à€¿à€€à¥
+pref.prespref=à€žà€Ÿà€Šà€°à¥à€à€°à€£à€Ÿà€à€Ÿ à€ªà¥à€°à€Ÿà€§à€Ÿà€šà¥à€¯à€à¥à€°à€®
+pref.interfacelang=à€Šà€°à¥à€¶à€šà¥ à€­à€Ÿà€·à€Ÿ:
+pref.encoding=à€žà€à€à¥à€·à€¿à€ªà¥à€€ à€°à¥à€ªà¥à€à€°à€£
+pref.all=à€žà€°à¥à€µ  
+pref.set_prefs=à€ªà¥à€°à€Ÿà€§à€Ÿà€šà¥à€¯ à€šà€¿à€¶à¥à€à€¿à€€ à€à€°à€Ÿ
+query.wordcount=à€¶à€¬à¥à€Š à€žà€à€à¥à€¯à€Ÿ:
+query.nodocsmatch=à€à¥à€£à€€à¥à€¹à¥ à€Šà€žà¥à€€à€à€µà€ à€ªà¥à€°à€¶à¥à€šà€Ÿà€¶à¥ à€à¥à€³à€²à¥ à€šà€Ÿà€¹à¥à€€
+query.onedocsmatch=à¥§ à€Šà€žà¥à€€à€à€µà€ à€ªà¥à€°à€¶à¥à€°à€Ÿà€¶à¥ à€à¥à€³à€²à€Ÿ
+query.matches=à€à¥à€³à€£à€Ÿà€°à€Ÿ
+query.results=à€šà€¿à€à€Ÿà€²
+document.gotopage=à€¯à€Ÿ à€ªà€Ÿà€šà€Ÿà€µà€° à€à€Ÿ
+doc.expand_doc_b=à€®à€à€à¥à€° à€µà€¿à€žà€°
+doc.expand_doc_tip=à€žà€°à¥à€µ à€®à€Ÿà€¹à€¿à€€à¥ à€¬à€à€Ÿ
+doc.contract_doc_b=à€®à€à€à¥à€° à€žà€à€à¥à€·à€¿à€ªà¥à€€ à€à€Ÿ
+doc.contract_doc_tip=à€žà€§à¥à€¯à€Ÿ à€šà€¿à€µà€¡ à€à¥à€²à¥à€²à€¯à€Ÿ à€µà€¿à€­à€Ÿà€à€Ÿà€€à¥à€² à€®à€Ÿà€¹à€¿à€€à¥ à€¬à€à€Ÿ
+
+doc.expand_contents_b=à€
+à€šà¥à€à¥à€°à€®à€£à€¿à€à€Ÿ à€µà€¿à€žà¥à€€à€Ÿà€°à€Ÿà€šà¥ à€¬à€à€Ÿ
+doc.expand_contents_tip=à€
+à€šà¥à€à¥à€°à€®à€£à€¿à€à€Ÿ à€µà€¿à€žà¥à€€à€Ÿà€°à€Ÿà€šà¥ à€¬à€à€Ÿ
+doc.contract_contents_b=à€
+à€šà¥à€à¥à€°à€®à€£à€¿à€à€Ÿ à€žà€à€à¥à€·à€¿à€€ à€à€°à€Ÿ
+doc.contract_contents_tip=à€à¥à€°à€®à€µà€Ÿà€°à¥à€€ à€¯à¥à€€ à€šà€Ÿà€¹à¥.
+doc.detach_page_b=à€µà€¿à€¯à¥à€à¥à€€ à€à€°à€Ÿ
+doc.detach_page_tip=à€¹à¥ à€ªà€Ÿà€š à€šà€µà¥à€š à€à€¿à€¡à€à¥à€®à€§à¥à€¯à¥ à€à€à€¡à€Ÿ
+param.sortBy.1=à€à€³à¥à€€
+param.sortBy.0=à€šà¥à€žà€°à¥à€à€¿à€
+param.fqf=à€à¥à€·à¥à€€à¥à€°à¥
+param.fqf.all=à€žà€°à¥à€µ à€à¥à€·à¥à€€à¥à€°à¥