Index: greenstone3/trunk/web/WEB-INF/classes/interface_default_ka.properties
===================================================================
--- greenstone3/trunk/web/WEB-INF/classes/interface_default_ka.properties	(revision 14466)
+++ greenstone3/trunk/web/WEB-INF/classes/interface_default_ka.properties	(revision 14466)
@@ -0,0 +1,44 @@
+home_b=áááááá á áááá áá
+pref_b=ááá áááá¢á ááá
+help_b=ááá®ááá ááá
+about_t=áá ááá¥á¢áá¡ ášáá¡áá®áá
+texticonpdf=PDF áááá£áááá¢áá¡ ááá®áá
+texticonps=PostScript  áááá£áááá¢áá¡ ááá®áá
+texticonrtf=RTF áááá£áááá¢áá¡ ááá®áá
+texticonmsword=Microsoft Word  áááá£áááá¢áá¡ ááá®áá
+texticonppt=PowerPoint-áá¡  áááá£áááá¢áá¡ ááá®áá
+texticonxls=Microsoft Excel áááá£áááá¢áá¡ ááá®áá
+gsdl=áá ááá¡á¢áá£ááá¡ áªáá€á á£áá ááááááááááá¡ áá ááá ááá£áá á£áá á£ááááá§áá€á
+home_tip=áááááá á áááá áá
+help_tip=ááá®ááá áááá¡ áááá áá
+pref_tip=ááá áááá¢á áááá¡ ášááªááá
+home_t=áááááá á áááá áá
+home.aboutgs=áá ááá¡á¢áá£ááá¡ ášáá¡áá®áá
+aboutpage=ááááá¥áªááá¡ ášáá¡áá®áá
+about.howtofind=á áááá  áááá«ááááá ááá€áá áááªáá  -  ááááá¥áªááášá
+pref.searchpref=ááá áááá¢á áááá¡ á«áááá
+pref.prespref=áá ááááá¢ááªááá¡ ááá áááá¢á ááá
+pref.interfacelang=ááá¢áá á€ááá¡áá¡ ááá:
+pref.encoding=ááááá ááá:
+pref.all=á§áááá
+pref.set_prefs=ááá áááá¢á áááá¡ ááá§ááááá
+query.wordcount=á¡áá¢á§ááááá¡ á áááááááá: 
+query.nodocsmatch=ášááááá®ááá¡ ášáá¡áááááá¡á áááá£áááá¢ááá áá  áá á¡ááááá¡
+query.onedocsmatch=ášááááá®ááá¡  ášááá¡áááááááá1 áááá£áááá¢á.
+query.matches=ášáá¡áááááá¡á áááá£áááá¢ááá
+query.results=ášááááá  (ááá£ááá¡á®áááá Found Results:)
+document.gotopage=ááááá¡ááá áááá ááá
+doc.expand_doc_b=á¢áá¥á¡á¢áá¡\nááášáá
+doc.expand_doc_tip=ááááá á¢áá¥á¡á¢áá¡ ááááá¢ááá
+doc.contract_doc_b=á®ááášááá á£ááááá¡\ná¢áá¥á¡á¢á
+doc.contract_doc_tip=á¢áá¥á¡á¢áá¡ ááááá¢ááá áá®áááá áá®ááá áá á©áá£áá áááá§áá€áááááááá
+doc.expand_contents_b=á¡áá á©áááá¡\nááášáá
+doc.expand_contents_tip=á¡áá á©áááá¡ ááá€áá ááááá
+doc.contract_contents_b=á®ááášááá á£ááááá¡\nášááááá á¡á
+doc.contract_contents_tip=á¡áá á©áááá¡ ááááªáá
+doc.detach_page_b=áá®ááá\ná€ááá¯áá á
+doc.detach_page_tip=áááá ááá¡ ááá®á¡áá áá®áá á€ááá¯áá áášá
+param.sortBy.1=á ááááá ááá£áá
+param.sortBy.0=á©ááá£áááá ááá
+param.fqf=... áááášá
+param.fqf.all=á§áááá áááá