Index: /greenstone3/trunk/web/interfaces/classic/interfaceConfig.xml
===================================================================
--- /greenstone3/trunk/web/interfaces/classic/interfaceConfig.xml	(revision 14481)
+++ /greenstone3/trunk/web/interfaces/classic/interfaceConfig.xml	(revision 14482)
@@ -22,5 +22,54 @@
   </actionList>
   <languageList>
+  	<language name='ar' displayname='Arabic' default_encoding='windows-1256'/>
+  	<language name='bg' displayname='Bulgarian' default_encoding='utf-8'/>
+  	<language name='bn' displayname='àŠ¬àŠŸàŠàŠ²àŠŸ (Bengali)' default_encoding='utf-8'/>
+  	<language name='ca' displayname='CatalÃ  (Catalan)' default_encoding='utf-8'/>
+  	<language name='cs' displayname='Äesky (Czech)' default_encoding='utf-8'/>
+  	<language name='de' displayname='Deutsch (German)' default_encoding='utf-8'/>
+  	<language name='el' displayname='ÎÎ»Î»Î·ÎœÎ¹ÎºÎ¬ (Greek)' default_encoding='windows-1253'/>
     <language name='en' displayname='English' default_encoding='utf-8'/>
+    <language name='es' displayname='EspaÃ±ol' default_encoding='utf-8'/>
+    <language name='fa' displayname='Farsi' default_encoding='utf-8'/>
+    <language name='fi' displayname='Finnish' default_encoding='utf-8'/>
+    <language name='fr' displayname='FranÃ§ais' default_encoding='utf-8'/>    
+    <language name='gd' displayname='Gaelic (Scottish)' default_encoding='utf-8'/>
+    <language name='gl' displayname='Galician' default_encoding='utf-8'/>
+    <language name='he' displayname='Hebrew' default_encoding='windows-1255'/>
+    <language name='hi' displayname='Hindi' default_encoding='utf-8'/>
+    <language name='hu' displayname='Hungarian' default_encoding='utf-8'/>
+    <language name='hy' displayname='Armenian' default_encoding='utf-8'/>
+    <language name='id' displayname='Bahasa Indonesia (Indonesian)' default_encoding='utf-8'/>
+    <language name='it' displayname='Italiano' default_encoding='utf-8'/>    
+    <language name='jp' displayname='ã«ã»ãã' default_encoding='utf-8'/>
+    <language name='ka' displayname='Georgian' default_encoding='utf-8'/>
+    <language name='kk' displayname='ÒÐ°Ð·Ð°Ò (Kazakh)' default_encoding='utf-8'/>
+    <language name='kn' displayname='Kannada' default_encoding='utf-8'/>
+    <language name='ky' displayname='ÐÑÑÐ³ÑÐ·ÑÐ° (Kirghiz)' default_encoding='utf-8'/>    
+    <language name='lv' displayname='Latvian' default_encoding='utf-8'/>
+	<language name='mi' displayname='MÄori' default_encoding='utf-8'/>
+	<language name='ml' displayname='Malayalam' default_encoding='utf-8'/>
+	<language name='mn' displayname='ÐÐŸÐœÐ³ÐŸÐ» (Mongolian)' default_encoding='utf-8'/>
+	<language name='mr' displayname='Marathi' default_encoding='utf-8'/>
+	<language name='nl' displayname='Nederlands (Dutch)' default_encoding='utf-8'/>
+	<language name='pl' displayname='polski (Polish)' default_encoding='utf-8'/>
+	<language name='pt-br' displayname='portuguÃªs-BR (Brasil)' default_encoding='utf-8'/>
+	<language name='pt-pt' displayname='portuguÃªs-PT (Portugal)' default_encoding='utf-8'/>
+	<language name='ps' displayname='Pushto' default_encoding='utf-8'/>
+	<language name='prs' displayname='Dari' default_encoding='utf-8'/>
+	<language name='ro' displayname='Romanian' default_encoding='utf-8'/>
+	<language name='ru' displayname='ÑÑÑÑÐºÐžÐ¹ (Russian)' default_encoding='windows-1251'/>
+	<language name='si' displayname='Sinhalese' default_encoding='utf-8'/>
+	<language name='sk' displayname='SlovenÄina (Slovak)' default_encoding='utf-8'/>
+	<language name='sr' displayname='Serbian' default_encoding='utf-8'/>
+	<language name='ta' displayname='Tamil' default_encoding='utf-8'/>	
+	<language name='te' displayname='Telugu' default_encoding='utf-8'/>
+	<language name='th' displayname='Thai' default_encoding='utf-8'/>
+	<language name='tr' displayname='Turkish' default_encoding='windows-1254'/>
+	<language name='uk' displayname='Ukrainian' default_encoding='utf-8'/>
+	<language name='ur' displayname='Urdu' default_encoding='utf-8'/>
+	<language name='vi' displayname='Tiáº¿ng Viá»t' default_encoding='utf-8'/>
+	<language name='zh' displayname='ç®äœäž­æ (Simplified Chinese)' default_encoding='gbk'/>
+	<language name='zh-tr' displayname='ç¹é«äž­æ (Traditional Chinese)' default_encoding='big5'/>
   </languageList>
 </interfaceConfig>