Index: /greenstone3/trunk/web/interfaces/default/interfaceConfig.xml
===================================================================
--- /greenstone3/trunk/web/interfaces/default/interfaceConfig.xml	(revision 14496)
+++ /greenstone3/trunk/web/interfaces/default/interfaceConfig.xml	(revision 14497)
@@ -38,4 +38,145 @@
       <displayItem name='name'>ã«ã»ãã</displayItem>
     </language>
+    <language name="vi">
+      <displayItem name='name'>Vietnamese</displayItem>
+    </language>
+    <language name='ar'>
+      <displayItem name='name'>Arabic</displayItem>
+    </language>
+  	<language name='bg'>
+      <displayItem name='name'>Bulgarian</displayItem>
+    </language>
+  	<language name='bn'>
+      <displayItem name='name'>àŠ¬àŠŸàŠàŠ²àŠŸ (Bengali)</displayItem>
+    </language>
+  	<language name='ca'>
+      <displayItem name='name'>CatalÃ  (Catalan)</displayItem>
+    </language>
+  	<language name='cs'>
+      <displayItem name='name'>Äesky (Czech)</displayItem>
+    </language>
+  	<language name='de'>
+      <displayItem name='name'>Deutsch (German)</displayItem>
+    </language>
+  	<language name='el'>
+      <displayItem name='name'>ÎÎ»Î»Î·ÎœÎ¹ÎºÎ¬ (Greek)</displayItem>
+    </language>
+    <language name='fa'>
+      <displayItem name='name'>Farsi</displayItem>
+    </language>
+    <language name='fi'>
+      <displayItem name='name'>Finnish</displayItem>
+    </language>
+    <language name='gd'>
+      <displayItem name='name'>Gaelic (Scottish)</displayItem>
+    </language>
+    <language name='gl'>
+      <displayItem name='name'>Galician</displayItem>
+    </language>
+    <language name='he'>
+      <displayItem name='name'>Hebrew</displayItem>
+    </language>
+    <language name='hi'>
+      <displayItem name='name'>Hindi</displayItem>
+    </language>
+    <language name='hu'>
+      <displayItem name='name'>Hungarian</displayItem>
+    </language>
+    <language name='hy'>
+      <displayItem name='name'>Armenian</displayItem>
+    </language>
+    <language name='id'>
+      <displayItem name='name'>Bahasa Indonesia (Indonesian)</displayItem>
+    </language>
+    <language name='it'>
+      <displayItem name='name'>Italiano</displayItem>
+    </language>    
+    <language name='ka'>
+      <displayItem name='name'>Georgian</displayItem>
+    </language>
+    <language name='kk'>
+      <displayItem name='name'>ÒÐ°Ð·Ð°Ò (Kazakh)</displayItem>
+    </language>
+    <language name='kn'>
+      <displayItem name='name'>Kannada</displayItem>
+    </language>
+    <language name='ky'>
+      <displayItem name='name'>ÐÑÑÐ³ÑÐ·ÑÐ° (Kirghiz)</displayItem>
+    </language>    
+    <language name='lv'>
+      <displayItem name='name'>Latvian</displayItem>
+    </language>
+	<language name='mi'>
+      <displayItem name='name'>MÄori</displayItem>
+    </language>
+	<language name='ml'>
+      <displayItem name='name'>Malayalam</displayItem>
+    </language>
+	<language name='mn'>
+      <displayItem name='name'>ÐÐŸÐœÐ³ÐŸÐ» (Mongolian)</displayItem>
+    </language>
+	<language name='mr'>
+      <displayItem name='name'>Marathi</displayItem>
+    </language>
+	<language name='nl'>
+      <displayItem name='name'>Nederlands (Dutch)</displayItem>
+    </language>
+	<language name='pl'>
+      <displayItem name='name'>polski (Polish)</displayItem>
+    </language>
+	<language name='pt-br'>
+      <displayItem name='name'>portuguÃªs-BR (Brasil)</displayItem>
+    </language>
+	<language name='pt-pt'>
+      <displayItem name='name'>portuguÃªs-PT (Portugal)</displayItem>
+    </language>
+	<language name='ps'>
+      <displayItem name='name'>Pushto</displayItem>
+    </language>
+	<language name='prs'>
+      <displayItem name='name'>Dari</displayItem>
+    </language>
+	<language name='ro'>
+      <displayItem name='name'>Romanian</displayItem>
+    </language>
+	<language name='ru'>
+      <displayItem name='name'>ÑÑÑÑÐºÐžÐ¹ (Russian)</displayItem>
+    </language>
+	<language name='si'>
+      <displayItem name='name'>Sinhalese</displayItem>
+    </language>
+	<language name='sk'>
+      <displayItem name='name'>SlovenÄina (Slovak)</displayItem>
+    </language>
+	<language name='sr'>
+      <displayItem name='name'>Serbian</displayItem>
+    </language>
+	<language name='ta'>
+      <displayItem name='name'>Tamil</displayItem>
+    </language>	
+	<language name='te'>
+      <displayItem name='name'>Telugu</displayItem>
+    </language>
+	<language name='th'>
+      <displayItem name='name'>Thai</displayItem>
+    </language>
+	<language name='tr'>
+      <displayItem name='name'>Turkish</displayItem>
+    </language>
+	<language name='uk'>
+      <displayItem name='name'>Ukrainian</displayItem>
+    </language>
+	<language name='ur'>
+      <displayItem name='name'>Urdu</displayItem>
+    </language>
+	<language name='vi'>
+      <displayItem name='name'>Tiáº¿ng Viá»t</displayItem>
+    </language>
+	<language name='zh'>
+      <displayItem name='name'>ç®äœäž­æ (Simplified Chinese)</displayItem>
+    </language>
+	<language name='zh-tr'>
+      <displayItem name='name'>ç¹é«äž­æ (Traditional Chinese)</displayItem>
+    </language>
   </languageList>
   <optionList>